class CreateCrontabs < ActiveRecord::Migration
  def self.up
    create_table :crontabs do |t|
      t.column :time_at, :timestamp, :null => false
      t.column :command, :string, :null => false
      # interval is x minutes(60 seconds)
      t.column :interval, :integer
    end

    execute "INSERT INTO crontabs (time_at, command, interval) VALUES ('#{3.minutes.from_now.strftime "%Y-%m-%d %H:%M:%S"}', 'GuildOrder.process_system_order', 60)"
    execute "INSERT INTO crontabs (time_at, command, interval) VALUES ('#{5.minutes.from_now.strftime "%Y-%m-%d %H:%M:%S"}', 'User.get_standard_items', 30)"
    execute "INSERT INTO crontabs (time_at, command, interval) VALUES ('#{9.minutes.from_now.strftime "%Y-%m-%d %H:%M:%S"}', 'LocationPick.supply_location_stocks', 30)"
    execute "INSERT INTO crontabs (time_at, command, interval) VALUES ('#{13.minutes.from_now.strftime "%Y-%m-%d %H:%M:%S"}', 'ShopStock.supply_shop_stocks', 30)"
  end

  def self.down
    drop_table :crontabs
  end
end
